Subject: Re: prompt update and TRAPCHLD
From: Vincent Lefevre <[email-masked]>
To: [email-masked]
Date: Thu, 21 Jan 2016 14:51:20 +0100
List-Id: Zsh Workers List <zsh-workers.zsh.org>

On 2016-01-14 18:59:41 -0800, Bart Schaefer wrote:
> The right thing is to explicitly tell ZLE to update the prompt:
> 
> TRAPCHLD() {
>   psvar[1]=$RANDOM
>   [[ -o zle ]] && zle reset-prompt
> }  

There's something wrong with it:

cventin:~> where TRAPCHLD                                             <14:00:55
TRAPCHLD () {
        [[ -o zle ]] && zle reset-prompt
}
cventin:~> echo &                                                     <14:00:59

[1] 23998
[1]  + done       echo                                                          
TRAPCHLD:zle: widgets can only be called when ZLE is active

> Or perhaps your complaint is that the TRAP* function should run sooner?

I think I was surprised when doing some tests. I thought that there
was some race condition in my code because the TRAPCHLD was run too
soon, but that's the opposite! So, the problem is something else.

I've now a better view of what happens. I have something like:

updprompt()
{
  local njobs=$#jobstates
  echo "--> $njobs" > /dev/tty
  print -nP "\e]2;${njobs}\x07" > /dev/tty
  echo "--> $njobs" > /dev/tty
}

(the "echo ..." are mainly added for the test).

precmd() { updprompt }

TRAPCHLD() { if [[ -o interactive && -n $TTY ]] then updprompt; fi }

When I type "echo &", in the command line, I generally get:

cventin:~> echo &                                                     <14:45:58

[1] 29151
--> 1                                                                           
--> 1
[1]  + done       echo
--> 0
--> 0

with "0" in the terminal window title, but I sometimes get:

cventin:~> echo &                                                     <14:45:59

[1] 29153
--> 1                                                                           
[1]  + done       echo
--> 0
--> 0
--> 1

with "1" in the terminal window title.

Now, I don't understand how this is possible if TRAPCHLD is run
after the prompt is redrawn, i.e. after updprompt has completed
in precmd!

-- 
Vincent Lefèvre <[email-masked]> - Web: <https://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <https://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / AriC project (LIP, ENS-Lyon)